/* Continuously prints sixty bytes of a file, while increasing the offset.
 * Public domain code by Norbert, 2016-11-08.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#define EXIT_NORMAL 0
#define EXIT_ERROR 1
#define PROGRAM_NAME "hexprint"
#define MAX_PATHFILE 100

#ifndef O_BINARY
#define O_BINARY 0
#endif

/*****************************************************************************/
int main (int argc, char *argv[])
/*****************************************************************************/
{
	char sIn[MAX_PATHFILE + 2];
	int iFd;
	int iRead;
	unsigned char sRead[60 + 2];
	int iEOF;
	int iOffset;
	int iByte;
	unsigned char cPrint;

	if (argc != 2)
	{
		printf ("Usage: ./%s <in>\n"
			"\t<in> = Existing in-file.\n\n",
			PROGRAM_NAME);
		exit (EXIT_NORMAL);
	} else {
		snprintf (sIn, MAX_PATHFILE, "%s", argv[1]);
	}

	iFd = open (sIn, O_RDONLY|O_BINARY);
	if (iFd == -1)
	{
		printf ("[FAILED] Could not open \"%s\": %s!\n",
			sIn, strerror (errno));
		exit (EXIT_ERROR);
	}

	iEOF = 0;

	iOffset = 0;
	do {
		lseek (iFd, iOffset, SEEK_SET);
		iRead = read (iFd, sRead, 60);
		switch (iRead)
		{
			case -1:
				printf ("[FAILED] Could not read from \"%s\": %s!\n",
					sIn, strerror (errno));
				exit (EXIT_ERROR);
				break;
			case 0: iEOF = 1; break;
			default:
				for (iByte = 0; iByte < 60; iByte++)
				{
					cPrint = sRead[iByte];
					while (cPrint < 0) { cPrint+=32; }
					/*** while (cPrint > 32) { cPrint-=32; } ***/
					printf ("%02X ", cPrint);
				}
				printf ("\n");
				break;
		}
		iOffset++;
	} while (iEOF == 0);

	close (iFd);

	exit (EXIT_NORMAL);
}
/*****************************************************************************/
